***************************** QSILVER.PRC *********************************
*
* This is the procedure file used by the main terminal emulation program
* named TRM_QSIL.PRG .  It is only useful for QuickSilver.
*
***************************** GotAKey *************************************
* Anytime a key gets pressed, Fox jumps here
*
PROCEDURE GotAKey
PARAMETERS Key

ON KEY                      && Disable key trapping for now
DO CASE                     && Decide whether key is data to output or local command
    CASE Key = 27           && ESC hit ?
        IF 'ACTIVE' $ ChkCmd        && File transfer active ?
            CALL COMET WITH 'FLUSH' && If so, user wants to cancel it
        ELSE
            DO ShutDown             && If no active file transfer, then quit
        ENDIF
    CASE Key > 0            && data to output ?
        IF .NOT. 'ACTIVE' $ ChkCmd      && Don't try to output if some type of file transfer active
            Output = "OUTPUT " + CHR(Key)   && Build OUTPUT command
            CALL COMET WITH Output          && Output char to COM port
        ELSE
            @0,0 CLEAR TO 23,79
            ?? CHR(7)
            @ 4,0 TO 12,79 DOUBLE
            @ 6,2 SAY "Sorry but we're busy " + event + "ing a file now!"
            @ 7,2 SAY "But, that fact that I can display this alert box "
            @ 8,2 say "proves COMET is running in the background."
            @ 9,2 say "Hit the 'D' key and I'll do a !DIR command in DOS."
            @10,2 say "Hit any key ..."
            * Wait loop
            Cnt = 0
            Secs = 0
            LastTime = TIME()
            Ky = INKEY()
            DO WHILE Ky = 0 .AND. Secs < 5
                Ky = INKEY()
                IF LastTime <> TIME()
                    Secs = Secs + 1
                     LastTime = TIME()
                 ENDIF
             ENDDO
            IF ky = ASC('D') .OR. ky = ASC('d')
                !DIR
            ENDIF
        ENDIF
OTHERWISE                   && If INKEY() < 0, then a function key was hit
    DO Local
ENDCASE

ON KEY DO GotAKey WITH INKEY() && Enable ON KEY again
RETURN


****************************** Local ***************************************
* Support for function keys (ie. local commands like send and receive)
PROCEDURE Local

DO CASE
    CASE Key = F2               && Clear screen ?
        @ 0,0 CLEAR TO 23,79
        @ 0,0
    CASE Key = F3               && Send file ?
        DO TranFile WITH 'SEND'
    CASE Key = F4               && Receive file ?
        DO TranFile WITH 'RECV'
    CASE Key = F10              && ONTIME command requesting STATUS update ?
        DO Status

ENDCASE

RETURN

************************ TranFile *******************************************
PROCEDURE TranFile
PARAMETERS Action
* Prompt for X or Ymodem  and filename to send/recv (including path)
IF 'ACTIVE' $ ChkCmd        && We're good, but not that good that we can have two transfers simultaneously!
    Msg = 'Request denied !  There is a file transfer ACTIVE'
SET COLOR TO N/W
@24,0
@24,0 SAY Msg
* Wait loop
Cnt = 0
Secs = 0
LastTime = TIME()
Ky = INKEY()
DO WHILE Ky = 0 .AND. Secs < 5
    Ky = INKEY()
    IF LastTime <> TIME()
        Secs = Secs + 1
        LastTime = TIME()
    ENDIF
ENDDO
Msg = LastMsg
@24,0
@24,0 SAY Msg
SET COLOR TO W/N
    RETURN
ENDIF

ExitFlg = .F.
@ 21,0

* Prompt for transfer protocol desired (Ascii, Xmodem or Ymodem)
* We don't use a VALID clause since DBASE doesn't support
TranHow = ' '
DO WHILE .NOT. (ExitFlg .OR. TranHow $ 'AXY')
    @ 21, 0 SAY 'Protocol (AXY) ' GET TranHow PICTURE '@! A'
    READ                            && Get protocol
    ExitFlg = IIF(READKEY()=12 .OR. READKEY()=268, .T., ExitFlg)
    ?? IIF(.NOT. TranHow $ 'AXY', CHR(7), '')   && Beep if invalid
ENDDO

* Prompt for filename except for YRECV since filename gets transmitted w/data
TranFil = SPACE(40)
IF .NOT. ExitFlg .AND. (TranHow <> 'Y' .OR. Action = 'SEND')
    @ 21, 20 SAY 'Filename ' GET TranFil PICTURE '@S30'
    READ
    ExitFlg = IIF(READKEY()=12 .OR. READKEY()=268, .T., ExitFlg)
ENDIF

* Prompt for timeout in seconds if ARECV, default is 60 secs
TimeOut = 60
IF .NOT. ExitFlg .AND. TranHow = 'A' .AND. Action = 'RECV'
    @ 21, 63 SAY 'Timeout ' GET TimeOut PICTURE "999"
    READ
    ExitFlg = IIF(READKEY()=12 .OR. READKEY()=268, .T., ExitFlg)
ENDIF

@ 21, 0
IF ExitFlg                    && Look for ESC key
    RETURN
ENDIF

*Now build COMET SEND or RECV command
TranCmd = TranHow + Action + ' ' + TRIM(TranFil)
IF 'ARECV' $ TranCmd .AND. TimeOut <> 60 && Test if we need ARECV timeout option
    TranCmd = TranCmd + ',' + STR(TimeOut,3,0)
ENDIF

* Issue command to COMET
CALL COMET WITH TranCmd         && Startup background file transfer

*Check that file transfer was able to start
ChkCmd = 'FCHK ' + SPACE(80)
CALL COMET WITH ChkCmd
IF .NOT. 'ACTIVE' $ ChkCmd       && Should be active if command started!
    LBracAt = AT('[',ChkCmd)     && Find start of FCHK failure description, if any
    IF LBracAt > 0               && If [ present, we have a failure description
        RBracAt = AT(']', ChkCmd)  && Find ] which is end of description
        Reason = SUBSTR(ChkCmd, LBracAt+1, RBracAt-LBracAt-1)
    ELSE
        Reason = 'GENERAL ERROR'
    ENDIF
    ?? CHR(7)                    && If wasn't successful at starting SEND, alert operator
    Msg = LEFT(Msg,37) + Action + ' Command Failed - ' + Reason
SET COLOR TO N/W
@24,0
@24,0 SAY Msg
* Wait loop
Cnt = 0
Secs = 0
LastTime = TIME()
Ky = INKEY()
DO WHILE Ky = 0 .AND. Secs < 5
    Ky = INKEY()
    IF LastTime <> TIME()
        Secs = Secs + 1
        LastTime = TIME()
    ENDIF
ENDDO
Msg = LastMsg
@24,0
@24,0 SAY Msg
SET COLOR TO W/N
    RETURN
ENDIF

Event = TranHow + Action            && This will be used by Status procedure
Thresh = 0
DO Status

*File Send or Recv in progress, now use ONTIME command to update status every 3 secs
*STATUS procedure will now execute every 3 seconds
OnTime = 'ONTIME 3,0,68'        && secs=3, ASCII code=0 , Aux Byte = 68  (F10 key)
CALL COMET WITH OnTime

RETURN                          && All done, returns back to Local proc


*************************** Status ************************************
* F10 key or COMET's ONTIME command brings us here
* Updates bottom line on screen with file transfer status
*
PROCEDURE Status

RowSave = ROW()
ColSave = COL()                 && Save cursor position
ChkCmd = 'FCHK ' + SPACE(80)
CALL COMET WITH ChkCmd          && Get current file transfer status

 * Now extract the status info we want; FCHK's status, size and filename
FCHKstat = SUBSTR(ChkCmd,22,8)  && Status - ACTIVE, COMPLETE or FAILED
FCHKsize = SUBSTR(ChkCmd,31,7)  && Size in bytes - #######
FCHKfile = SUBSTR(ChkCmd,39)    && Filename - path\filename (variable length)

* Adjust filename if necessary
SpcAt = AT(' ',FCHKfile)        && Look for end of path\filename
FCHKfile = IIF(SpcAt > 0, SUBSTR(FCHKfile,1,SpcAt-1), FCHKfile)
FCHKfile = IIF(LEN(FCHKfile) > 12, RIGHT(FCHKfile,12), FCHKfile)

* Append failure description to FCHKstat - if FAILED
IF 'FAILED' $ FCHKstat
    LBracAt = AT('[',ChkCmd)     && Find start of FCHK failure description, if any
    RBracAt = AT(']', ChkCmd)  && Find ] which is end of description
    Reason = SUBSTR(ChkCmd, LBracAt+1, RBracAt-LBracAt-1)
    FCHKstat = FCHKstat + Reason
    FCHKfile = ""               && Need the room to display failure description
ENDIF



* Display extracted status
Msg = LEFT(Msg,37) + Event + ' | ' + FCHKstat + ' | ' + FCHKsize + ' | ' + FCHKfile
SET COLOR TO N/W
@24,0
@24,0 SAY Msg
SET COLOR TO W/N

IF .NOT. 'ACTIVE' $ ChkCmd    && COMPLETEd or FAILED ?
    Thresh = Thresh + 1
    IF Thresh > 1               && Don't want to redisplay old stat msg till 1 cycle
        Ontime = 'ONTIME'
        CALL COMET WITH Ontime      && If so, turn off timer event trapping
        Msg = LastMsg
SET COLOR TO N/W
@24,0
@24,0 SAY Msg
SET COLOR TO W/N
    ELSE
        ?? CHR(7)               && Call attention to COMPLETE or FAILED status
    ENDIF
ENDIF
@ RowSave, ColSave SAY ''       && Restore cursor location
RETURN

********************* ShutDown ***************************************
* If an error occurs we want to shut COMET down smoothly !!!
*
PROCEDURE ShutDown

* 1st step is to FLUSH (cancel) any ongoing COMET activity
Flsh = "FLUSH "
CALL COMET WITH Flsh

* 2nd step is to CLOSE the COM port that we OPENed at start of program
Clse = "CLOSE "
CALL COMET WITH Clse

** NOW it's safe to QUIT or SUSPEND
QUIT

