***********************  TRM_CLIP.PRG  ****************************************
*
*    >>>>                                                    <<<<
*    >  Modify line 72 BEFORE running this program so that your <
*    >    particular modem config is known to this program.     <
*    >>>>                                                    <<<<
*
* This version runs under: Clipper S87 (Use EXTEND.OBJ at link time)
*
* This is a sample program which demonstrates a number of the COMET library
* commands used to emulate a simple terminal program. You should code in the
* phone number you need dialed directly into this demo program.
* Good luck & have fun !!!
*
* Command keys while in TERMINAL:
*   F2 - Clears the screen
*   F3 - Send a file or group of files(if Ymodem specified for protocol)
*   F4 - Receive a file or files(if Ymodem)
*   ESC - Suspends TERMINAL program
*******************************************************************************
*
SET TALK OFF
SET BELL OFF
PUBLIC Event, LF, Msg, ChkCmd, Thresh, LastMsg, Redisp, TranHow
PUBLIC _COMET_              && Used for error handling in new ERRORSYS.PRG
CLEAR

TranHow = ' '
SET KEY 27 TO GotESC

* Display sign-on message
@ 5, 13 TO 13,65 DOUBLE
@ 7,15 SAY 'TERMINAL - A Terminal Emulation Program Using ...'
@ 9,35 SAY '- COMET -'
@ 11,15 SAY 'The  B A C K G R O U N D  Communication Library'
SET COLOR TO N/W
@24,0
@ 24, 2 SAY 'COPYRIGHT(c) 1989 by  CompuSolve,  Rockaway, NJ  (201)983-9429'
SET COLOR TO W/N

A = INKEY(5)            && Wait 5 secs

CLEAR
SET COLOR TO N/W
@24,0
@ 24, 20 SAY  'Enter a telephone # to dial...'
SET COLOR TO W/N
@ 0,0
* Init variables
ChkCmd = ''

* Function keys used to invoke local commands
F1 = 28
F2 = -1                             && Clear Screen
F3 = -2                             && Send file
F4 = -3                             && Receive file
F10 = -9
Up = 5
Dn = 24
Rgt = 4
Lft = 19
BkSpc = 127


SET FUNC 'F2' TO
SET FUNC 'F3' TO
SET FUNC 'F4' TO
SET FUNC 'F10' TO


* 1st, open up our COM port [Put YOUR COM port#, baud rate etc. in next line]
Open = "OPEN COM1:2400,E,7,1"       && Build COMET OPEN command into <expC>
CALL COMET WITH Open                && COM port now opened for use, that was easy!

* Now we'll dial a phone#
* Request # to dial 1st
PhoneNo = SPACE(20)
ACCEPT "Phone No. to Dial ?" TO PhoneNo

* The ATTD is output to instruct HAYES compatible modems to dial a #
Dial = "OUTPUT ATTD" + PhoneNo + CHR(13)  && Build OUTPUT command
CALL COMET WITH Dial                && Have modem dial #

SET COLOR TO N/W
@ 24, 0
@ 24, 20 SAY   'Waiting for Carrier, Please Wait ...'
SET COLOR TO W/N
* Now, wait till we sense Data Carrier Detect(DCD) from our COM port.
Elapsed = 0                         && Simple timer for our DO .. WHILE loop
LastTime = TIME()                   && Also used for timing purposes
MdmStat = "MSTAT " + SPACE(25)        && Build MSTAT command
DO WHILE Elapsed <= 45 .AND. (.NOT. "+DCD" $ MdmStat)
    CALL COMET WITH MdmStat         && Get COM port's modem status

    IF LastTime <> TIME()           && Test if we need to updated timer count
        Elapsed = Elapsed+1         && Another second has gone by ..
        LastTime = TIME()
        @ 24,57 SAY STR(45-Elapsed,2) && Display #secs remaining till abort
    ENDIF
ENDDO

* Check if we timed out
IF Elapsed > 45
    ??CHR(7)
SET COLOR TO N/W
    @24, 0
    @24, 10 SAY "Sorry, can't establish phone connection. Aborting ..."
SET COLOR TO W/N
    DO ShutDown
ENDIF

* Now that we have a call established we have 2 things to do:
*  1) Check COMET's receive buffer and display any incoming characters
*  2) Detect any keystrokes and determine if local command or data to output


* Clear initial screen after connect, set status message
Msg = "F2 - Clear | F3 - Send | F4 - Recv | TERM"
LastMsg = Msg
SET COLOR TO N/W
@24,0
@ 24,10 SAY Msg
SET COLOR TO W/N
@ 0,0 CLEAR TO 23,79
@ 0,0

***************************************************************************
* Loop to:  1)Detect any keypress    2) Display any COM port received data
DO WHILE .T.
    OurKey = INKEY()           && Look for a key press
    IF OurKey <> 0
        DO GotAKey WITH OurKey
    ENDIF
 
    Term = CHR(10)          && Termination character = Line Feed
    Inp = "INPUT " + Term + SPACE(100)  && Build INPUT command
    CALL COMET WITH Inp   && Read COMET's COM port data buffer

    AmtRetd = VAL(SUBSTR(Inp,8,4))  && Determine how many chars were returned, if any
    ComData = SUBSTR(Inp, 12, AmtRetd)  && Get just the COM data from <expC>

* A loop to break down the COM data in order to deal with CR's & LF's
* This is a royal pain but need to do since we must not write to the last
* line (# 24). Line 24 is reseved as a help/status line.
    DO WHILE AmtRetd > 0
        CrAt = AT(CHR(13), ComData)     && Locate any CR's
        LfAt = AT(CHR(10), ComData)     && Locate any LF's
        DO CASE
            CASE CrAt > 0 .OR. LfAt > 0  && Print chars to left of a CR or LF for this pass
                NoToPrt = IIF(CrAt > 0, CrAt, LfAt) -1
                CRorLF = .T.
            OTHERWISE                   && No CR or LF, print as many as fit on current line
                NoToPrt = MIN(AmtRetd, 80-COL())
                CRorLF = .F.
        ENDCASE

        IF NoToPrt > 0                  && Print COM data (if any)
            ?? LEFT(ComData, NoToPrt)
            IF COL() = 0                && Did we get auto-CR/LF by writing to column 80 ?
                @ROW()-1, 79 SAY ''     && If so, backup to end of previuos line
            ENDIF
        ENDIF

    * Remove any printed COM data & CR/LF's for next loop
        ComData = STUFF(ComData, 1, NoToPrt + IIF(CRorLF, 1, 0), '')
        AmtRetd = LEN(ComData)

    * Here's our logic to do scrolling at bottom, and line feeds.
        DO CASE
            CASE ROW() > 23 .OR. (ROW()>=23 .AND. CrAt > 0)
                SCROLL(0,0,23,79,1)
                @ 23,0
            CASE CrAt > 0
                ?
        ENDCASE
     ENDDO


ENDDO                       && End of incoming data display loop
*
***************************************************************************


**************************** GotESC **************************************
PROCEDURE GotESC

DO GotAKey WITH 27
RETURN


***************************** GotAKey *************************************
* Anytime a key gets pressed, jump here
*
PROCEDURE GotAKey
PARAMETERS Key

DO CASE                     && Decide whether key is data to output or local command
    CASE Key = 27           && ESC hit ?
        IF 'ACTIVE' $ ChkCmd        && File transfer active ?
            CALL COMET WITH 'FLUSH' && If so, user wants to cancel it
        ELSE
            DO ShutDown             && If no active file transfer, then quit
        ENDIF
    CASE Key > 0            && data to output ?
        IF .NOT. 'ACTIVE' $ ChkCmd  .OR. TranHow = 'A'    && Output if: no file xfers active  OR  ASEND/ARECV
            Output = "OUTPUT " + CHR(Key)   && Build OUTPUT command
            CALL COMET WITH Output          && Output char to COM port
        ELSE
            @0,0 CLEAR TO 23,79
            ?? CHR(7)
            @ 4,0 TO 12,79 DOUBLE
            @ 6,2 SAY "Sorry but we're busy " + event + "ing a file now!"
            @ 7,2 SAY "But, that fact that I can display this alert box "
            @ 8,2 say "proves COMET is running in the background."
            @ 9,2 say "Hit the 'D' key and I'll do a !DIR command in DOS."
            @10,2 say "Hit any key ..."
            Ky = INKEY(5)
            IF ky = ASC('D') .OR. ky = ASC('d')
                !DIR
            ENDIF
        ENDIF
OTHERWISE                   && If INKEY() < 0, then a function key was hit
    DO Local
ENDCASE
RETURN


****************************** Local ***************************************
* Support for function keys (ie. local commands like send and receive)
PROCEDURE Local

DO CASE
    CASE Key = F2               && Clear screen ?
        @ 0,0 CLEAR TO 23,79
        @ 0,0
    CASE Key = F3               && Send file ?
        DO TranFile WITH 'SEND'
    CASE Key = F4               && Receive file ?
        DO TranFile WITH 'RECV'
    CASE Key = F10              && ONTIME command requesting STATUS update ?
        DO Status

ENDCASE

RETURN

************************ TranFile *******************************************
PROCEDURE TranFile
PARAMETERS Action
* Prompt for X or Ymodem  and filename to send/recv (including path)
IF 'ACTIVE' $ ChkCmd        && We're good, but not that good that we can have two transfers simultaneously!
SET COLOR TO N/W
    Msg =  'Request denied !  There is a file transfer ACTIVE'
    @24,0
    @24,10 SAY Msg
    A = INKEY(3)
    Msg = LastMsg
    @24,0
    @24,0 SAY Msg
SET COLOR TO W/N
    RETURN
ENDIF

ExitFlg = .F.
@ 23,0

* Prompt for transfer protocol desired (Ascii, Xmodem or Ymodem)
* We don't use a VALID clause since DBASE doesn't support
TranHow = ' '
DO WHILE .NOT. (ExitFlg .OR. TranHow $ 'AXY')
    @ 23, 0 SAY 'Protocol (AXY) ' GET TranHow PICTURE '@! A'
    READ                            && Get protocol
    ExitFlg = IIF(READKEY()=12 .OR. READKEY()=268, .T., ExitFlg)
    ?? IIF(.NOT. TranHow $ 'AXY', CHR(7), '')   && Beep if invalid
ENDDO

* Prompt for filename except for YRECV since filename gets transmitted w/data
TranFil = SPACE(40)
IF .NOT. ExitFlg .AND. (TranHow <> 'Y' .OR. Action = 'SEND')
    @ 23, 20 SAY 'Filename ' GET TranFil PICTURE '@S30'
    READ
    ExitFlg = IIF(READKEY()=12 .OR. READKEY()=268, .T., ExitFlg)
ENDIF

* Prompt for timeout in seconds if ARECV, default is 60 secs
TimeOut = 60
IF .NOT. ExitFlg .AND. TranHow = 'A' .AND. Action = 'RECV'
    @ 23, 63 SAY 'Timeout ' GET TimeOut PICTURE "999"
    READ
    ExitFlg = IIF(READKEY()=12 .OR. READKEY()=268, .T., ExitFlg)
ENDIF

@ 23, 0
IF ExitFlg                    && Look for ESC key
    RETURN
ENDIF

*Now build COMET SEND or RECV command
TranCmd = TranHow + Action + ' ' + TRIM(TranFil)
IF 'ARECV' $ TranCmd .AND. TimeOut <> 60 && Test if we need ARECV timeout option
    TranCmd = TranCmd + ',' + STR(TimeOut,3,0)
ENDIF

* Force COM port OPEN params to No parity & 8 data bits during any file xfers
OpnN8 = STUFF(Open,16,3,'N,8')  && Create modified version of original Open <expC>
CALL COMET WITH OpnN8

* Issue command to COMET
CALL COMET WITH TranCmd         && Startup background file transfer

*Check that file transfer was able to start
ChkCmd = 'FCHK ' + SPACE(80)
CALL COMET WITH ChkCmd
IF .NOT. 'ACTIVE' $ ChkCmd       && Should be active if command started!
    LBracAt = AT('[',ChkCmd)     && Find start of FCHK failure description, if any
    IF LBracAt > 0               && If [ present, we have a failure description
        RBracAt = AT(']', ChkCmd)  && Find ] which is end of description
        Reason = SUBSTR(ChkCmd, LBracAt+1, RBracAt-LBracAt-1)
    ELSE
        Reason = 'GENERAL ERROR'
    ENDIF
    ?? CHR(7)                    && If wasn't successful at starting SEND, alert operator
    SET COLOR TO N/W
    Msg = LEFT(Msg,37) + Action + ' Command Failed - ' + Reason
    @24, 0
    @24,0 SAY Msg
    A = INKEY(3)
    Msg = LastMsg
    @24, 0
    @24,0 SAY Msg
    SET COLOR TO W/N
    CALL COMET WITH Open            && Restore COM port OPEN params
    RETURN
ENDIF

Event = TranHow + Action            && This will be used by Status procedure
Thresh = 0
DO Status

*File Send or Recv in progress, now use ONTIME command to update status every 3 secs
*STATUS procedure will now execute every 3 seconds
OnTime = 'ONTIME 3,0,68'        && secs=3, ASCII code=0 , Aux Byte = 68  (F10 key)
CALL COMET WITH OnTime

RETURN                          && All done, returns back to Local proc

*************************** Status ************************************
* F10 key or COMET's ONTIME command brings us here
* Updates bottom line on screen with file transfer status
*
PROCEDURE Status

RowSave = ROW()
ColSave = COL()                 && Save cursor position
ChkCmd = 'FCHK ' + SPACE(80)
CALL COMET WITH ChkCmd          && Get current file transfer status

 * Now extract the status info we want; FCHK's status, size and filename
FCHKstat = SUBSTR(ChkCmd,22,8)  && Status - ACTIVE, COMPLETE or FAILED
FCHKsize = SUBSTR(ChkCmd,31,7)  && Size in bytes - #######
FCHKfile = SUBSTR(ChkCmd,39)    && Filename - path\filename (variable length)

* Adjust filename if necessary
SpcAt = AT(' ',FCHKfile)        && Look for end of path\filename
FCHKfile = IIF(SpcAt > 0, SUBSTR(FCHKfile,1,SpcAt-1), FCHKfile)
FCHKfile = IIF(LEN(FCHKfile) > 12, RIGHT(FCHKfile,12), FCHKfile)

* Append failure description to FCHKstat - if FAILED
IF 'FAILED' $ FCHKstat
    LBracAt = AT('[',ChkCmd)     && Find start of FCHK failure description, if any
    RBracAt = AT(']', ChkCmd)  && Find ] which is end of description
    Reason = SUBSTR(ChkCmd, LBracAt+1, RBracAt-LBracAt-1)
    FCHKstat = FCHKstat + Reason
    FCHKfile = ""               && Need the room to display failure description
ENDIF



* Display extracted status
Msg = LEFT(Msg,37) + Event + ' | ' + FCHKstat + ' | ' + FCHKsize + ' | ' + FCHKfile
SET COLOR TO N/W
@24,0
@24,0 SAY Msg
SET COLOR TO W/N

IF .NOT. 'ACTIVE' $ ChkCmd    && COMPLETEd or FAILED ?
    Thresh = Thresh + 1
    IF Thresh > 1               && Don't want to redisplay old stat msg till 1 cycle
        Ontime = 'ONTIME'
        CALL COMET WITH Ontime      && If so, turn off timer event trapping
        Msg = LastMsg
        SET COLOR TO N/W
        @24,0
        @24,0 SAY Msg
        SET COLOR TO W/N
    ELSE
        ?? CHR(7)               && Call attention to COMPLETE or FAILED status
        CALL COMET WITH Open            && Restore COM port OPEN params
    ENDIF
ENDIF

@ RowSave, ColSave SAY ''       && Restore cursor location
RETURN


********************* ShutDown ***************************************
* If an error occurs we want to shut COMET down smoothly !!!
*
PROCEDURE ShutDown

* 1st step is to FLUSH (cancel) any ongoing COMET activity
Flsh = "FLUSH "
CALL COMET WITH Flsh

* 2nd step is to CLOSE the COM port that we OPENed at start of program
Clse = "CLOSE "
CALL COMET WITH Clse

** NOW it's safe to QUIT or SUSPEND
QUIT


